<?php
// needle
if(empty($db_tab)) include("_dat.inc.php");
if(! class_exists(db_bsx)) include("_sql.php");
if(! function_exists(gettemplate)) include("_func.php");
if(! isset($bsx_conf)) $bsx_conf = get_config();

/*
* return: Message String
* param: ID der News
* usage: $ncommsg = add_ncom($show_id, $HTTP_POST_VARS);
* desc: Trgt neue Kommentare fr News ein ...
*/	
if(! function_exists(add_ncom)) {
	function add_ncom ($ID, $parray) {
		
		global $db_host, $db_name, $db_user, $db_pass, $db_tab, $go;
		
		if((empty($parray[author])) || (empty($parray[titel])) || (empty($parray[text]))) {
			return "<p><center>Felder mit <font color=red>*</font> gekennzeichnet sind Pflichtfelder!</center></p>\n";
		} else {
			$author = addslashes($parray[author]);
			$mail = addslashes($parray[mail]);
			$titel = addslashes($parray[titel]);
			$kommentar = addslashes($parray[text]);
			$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
			$query = $dbcon->db_ins("INSERT INTO ".$db_tab[news_com]." (news_id, title, comment, author, email, Datum) VALUES ('$ID', '$titel', '$kommentar', '$author', '$mail', '".time()."')");
			$close = $dbcon->close();
			if(! $query) {
				return "<p><center>Fehler beim eintragen des Kommentares!</center></p>\n";
			} else {
				return "<p><center>Kommentar erfolgreich eingetragen!</center></p>\n";
			}
		}
		unset($ID, $query, $parray);
	}	
}
/*
* return: ARRAY
* param: NewsID
* usage: fetch_newscom($show_id);
* desc: Liest die Kommentare zu den News aus ...
*/	
if(! function_exists(fetch_newscom)) {
	function fetch_newscom ($ID) {
		
		global $db_host, $db_name, $db_user, $db_pass, $db_tab, $elem, $bsx_conf, $links, $go, $QUERY_STRING;
		
		if(! isset($go)) $go = 0;
		
		$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
		$com_anz = $dbcon->db_rows("SELECT * FROM ".$db_tab[news_com]." WHERE news_id = $ID");
		$com_query = $dbcon->db_fetch_multi("SELECT * FROM ".$db_tab[news_com]." WHERE news_id = $ID LIMIT $go,".$bsx_conf[news_com_max]."");
		$close = $dbcon->close();
		if(empty($com_query)) {
			$newscomment = "<p><center>Noch keine Kommentare vorhanden!</center></p>";
		} else {
			foreach($com_query as $query_detail) {
				foreach($query_detail as $key=>$elem) {
				$newscomment[] = $elem;
				}
			}
			$links = site_view($go, $bsx_conf[news_com_max], $com_anz);
			return $newscomment;
			unset($elem, $newscomment, $com_query, $query_detail, $ID);
		}
	}	
}
/*
* return: ARRAY
* param: ID der News
* usage: give_back(fetch_singlenews($show_id), "news");
* desc: Liest einen News Eintrag aus ...
*/	
if(! function_exists(fetch_singlenews)) {
	function fetch_singlenews ($ID) {
		
		global $db_host, $db_name, $db_user, $db_pass, $db_tab, $elem;
		
		$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
		$elem = $dbcon->db_fetch("SELECT * FROM ".$db_tab[news]." WHERE id = $ID  AND active = '1'");
		$elem[anz] = $dbcon->db_rows("SELECT * FROM ".$db_tab[news_com]." WHERE news_id = $ID");
		$close = $dbcon->close();
		return $elem;
		unset($elem);
		unset($ID);
	}	
}
/*
* return: ARRAY
* param: $anz
* usage: $news = fetch_allnews();
* desc: Liest alle News aus und gibt komplettes Array zurck
*/	
if(! function_exists(fetch_allnews)) {
	function fetch_allnews ($anz) {
		
		global $db_host, $db_name, $db_user, $db_pass, $db_tab;
		
		$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
		$query = $dbcon->db_fetch_multi("SELECT * FROM ".$db_tab[news]." WHERE active = '1' ORDER BY id DESC LIMIT 0,$anz");
		foreach($query as $query_detail) {
			foreach($query_detail as $key=>$elem) {
				$elem[anz] = $dbcon->db_rows("SELECT * FROM ".$db_tab[news_com]." WHERE news_id = $elem[id]");
				$newscon[] = $elem;
			}
		}
		$close = $dbcon->close();
		return $newscon;
		unset($elem, $newscon, $query, $query_detail, $anz);
	}	
}
/*
* return: ARRAY
* param: $anz, $spalte, $value
* usage: 
* desc: 
*/	
if(! function_exists(fetch_advanced_news)) {
	function fetch_advanced_news ($anz, $spalte, $value) {
		
		global $db_host, $db_name, $db_user, $db_pass, $db_tab;
		
		switch($spalte) {
			case "icon_title": $querystring = "WHERE icon_title = '$value' AND active = '1'";
			break;
			case "author": $querystring = "WHERE author = '$value' AND active = '1'";
			break;
			default: $querystring = "WHERE active = '1'";
		}
		$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
		$query = $dbcon->db_fetch_multi("SELECT * FROM $db_tab[news] ".$querystring."ORDER BY id DESC LIMIT 0,$anz");
		foreach($query as $query_detail) {
			foreach($query_detail as $key=>$elem) {
				$elem[anz] = $dbcon->db_rows("SELECT * FROM ".$db_tab[news_com]." WHERE news_id = $elem[id]");
				$newscon[] = $elem;
			}
		}
		$close = $dbcon->close();
		return $newscon;
		unset($elem, $newscon, $query, $query_detail, $anz, $spalte, $value);
	}	
}
/*
* return: Array
* param: string (min 3 zeichen)
* usage: $elem = search_newsstring($Suche);
* desc: Sucht in der News Datenbank nach $searchstring und gibt fund oder string zurck
*/	
if(! function_exists(search_newsstring)) {
	function search_newsstring ($searchstring) {
		
		global $db_host, $db_name, $db_user, $db_pass, $db_tab, $bsx_conf;
		
		if(strlen($searchstring) <= 2) {
			$elem[title] = "Gesuchtes Wort ist zu kurz <small>(*min 3 Zeichen)</small>!";
			return $elem;
			exit;
		}
		$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
		$res = $dbcon->db_fetch_multi("SELECT * FROM ".$db_tab[news]." WHERE title LIKE '%$searchstring%' OR news LIKE '%$searchstring%' AND active = '1' ORDER BY id DESC");
		$close = $dbcon->close();
		if($res) {
			foreach($res as $res_detail) {
				foreach($res_detail as $key=>$elem) {
					$elem[title] = "<a href=\"$PHP_SELF?show_id=$elem[id]&nshow=singlenews\" title=\"".stripslashes($elem[title])." vom ".date("d.m.Y", $elem[Datum])."\">".stripslashes($elem[title])."</a>\n";
					$elemres[] = $elem;
				}
			}
		} else { 
			$elemres[title] = "Keine Eintrge gefunden!";
		}
		return $elemres;
		unset($elemres, $elem, $res, $res_detail);		
	} 	
}	
/*
* return: Array
* param: string
* usage: $elem = search_newsdate($dat[from], $dat[to]);
* desc: sucht in der News Datenbank nach der gewissen Zeitspanne
*/	
if(! function_exists(search_newsdate)) {
	function search_newsdate ($from, $to) {
		
		global $db_host, $db_name, $db_user, $db_pass, $db_tab, $bsx_conf;
		      				
		$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
		$res = $dbcon->db_fetch_multi("SELECT id, title, Datum FROM ".$db_tab[news]." WHERE Datum > ".$from." AND Datum < ".$to." AND active = '1' ORDER BY id DESC");
		$close = $dbcon->close();
		if($res) {
			foreach($res as $res_detail) {
				foreach($res_detail as $key=>$elem) {
					$elem[title] = "<a href=\"$PHP_SELF?show_id=$elem[id]&nshow=singlenews\" title=\"".stripslashes($elem[title])." vom ".date("d.m.Y", $elem[Datum])."\">".stripslashes($elem[title])."</a>\n";
					$elemres[] = $elem;
				}
			}
		} else {
			$elemres[title] = "Keine Eintrge gefunden!";
		}
		return $elemres;
		unset($elemres, $elem, $res, $res_detail);	
	}
}
/*
* return: 
* param: 
* usage: $headline = fetch_headline($bsx_conf[nhl_max],$bsx_conf[nhl_modeval],$bsx_conf[nhl_mode]);
* desc: ruft nur die headlines (berschrift mit $bsx_conf[nhl_max] Anzahl Zeichen der News) auf
*/	
if(! function_exists(fetch_headline)) {
	function fetch_headline ($anz, $viewmax, $mode) {
		
		global $db_host, $db_name, $db_user, $db_pass, $db_tab, $elem, $bsx_conf;

		switch ($mode) {
			case "stk":
			$qstring = " ORDER BY Datum DESC LIMIT 0,$viewmax";
			break;
			case "m":
			$dat[from] = strtotime("-".$viewmax." month", strtotime("1 ".date("F")." ".date("Y")." 00:00:00"));
			$dat[to] = time();
			$qstring = " WHERE Datum > $dat[from] AND Datum < $dat[to] AND active = '1' ORDER BY id DESC";
			break;
			case "w":
			$dat[from] = strtotime("-".$viewmax." week");
			$dat[to] = time();
			$qstring = " WHERE Datum > $dat[from] AND Datum < $dat[to] AND active = '1' ORDER BY id DESC";
			break;
			case "d":
			$dat[from] = strtotime("-".$viewmax." day");
			$dat[to] = time();
			$qstring = " WHERE Datum > $dat[from] AND Datum < $dat[to] AND active = '1' ORDER BY id DESC";
			break;
		}
		if(empty($anz)) $anz = 5;
		if(empty($viewmax)) $viewmax = 30;
		$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
		$result = $dbcon->db_fetch_multi("SELECT id, title, news, author, Datum FROM $db_tab[news]".$qstring);
		$close = $dbcon->close();
		if(! $result) {
			$elem[news] = "<p><center>Keine Eintr&auml;ge gefunden!</center></p>\n";
			return $elem;
			exit;
		}
		foreach($result as $key=>$rsd) {
			foreach($rsd as $key=>$elem) {
				$elem[lnk] = "?show_id=$elem[id]&nshow=singlenews";
				$elem[title] = "<a href=\"".$elem[lnk]."\" title=\"... ganze News lesen!\">$elem[title]</a>";
				$elem[news] = substr(str_replace("<br>"," ",$elem[news]),0,$anz)." ...";
				$zw[] = $elem;
			}
		}
		return $zw;
		unset($result, $rsd, $elem);
	}	
}
/*
* return: String
* param: $array = Content / $templatestring = Templatename
* usage: print give_back(fetch_allnews(), "news");
* desc: Gibt den string mit dem(n) gefllten Template(s) zurck ...
*/	
if(! function_exists(give_back)) {
	function give_back ($array, $templatestring) {
		
		global $elem, $elemres, $dat, $bsx_conf;
		
		if(is_array($array[0])) {
			$x = 1;
			foreach($array as $key=>$elem) {
				if($x % 2 == 0)	{
					$elem[tdchange] = "{taba}";
					$elem[tdchangeclass] = "taba";
				} else {
					$elem[tdchange] = "{tabb}";
					$elem[tdchangeclass] = "tabb";
				}
				eval("\$content .= dooutput(\"".gettemplate($templatestring)."\");");
				$x++;
			}
		} 
		elseif(is_array($array)) {
			$elem[tdchange] = "{taba}";
			$elem[tdchangeclass] = "taba";
			eval("\$content = dooutput(\"".gettemplate($templatestring)."\");");
		} else {
			$elem[tdchange] = "{taba}";
			$elem[tdchangeclass] = "taba";
			print $array;  
		}
		return $content;
		unset($elem, $array, $templatestring, $x);
	}	
}

// $nshow Kram ;o)
if($nshow == "news") {
	eval("print dooutput(\"".addslashes(give_back(fetch_allnews($bsx_conf[news_max]), "news"))."\");");
}
if($nshow == "advancednews") {
	eval("print dooutput(\"".addslashes(give_back(fetch_advanced_news($bsx_conf[news_max], $spalte, $s_val), "news"))."\");");
}
if((! empty($show_id)) && ($nshow == "singlenews")) {
	print give_back(fetch_singlenews($show_id), "news");
}
if($nshow == "shownewscom") {
	print give_back(fetch_singlenews($show_id), "news");
	print give_back(fetch_newscom($show_id), "news_com");
	eval("print dooutput(\"".gettemplate("news_reply")."\");");
}
if($nshow == "addnewscom") {
	$ncommsg = add_ncom($show_id, Array("author" => $author, "mail" => $mail, "titel" => $titel, "text" => $message));
	print give_back(fetch_singlenews($show_id), "news");
	print give_back(fetch_newscom($show_id), "news_com");
	eval("print dooutput(\"".gettemplate("news_reply")."\");");
	unset($HTTP_POST_VARS, $show_id, $ncommsg, $nshow);
}
if($nshow == "newsarchiv") {
	if($send == "Suchen") {
		eval("\$elem = search_newsstring(\"$Suche\");");
		unset($nshow);
	}
	if($send == "Anzeigen") {
		eval("\$dat = kalendar($month, $year);");
		eval("\$elem = search_newsdate(\"".$dat[from]."\", \"".$dat[to]."\");");
		unset($nshow);
	}
	if(isset($send)) $newssearchbox = give_back($elem, "news_searchres");
	eval("print dooutput(\"".gettemplate("news_search")."\");");
}
if($nshow == "headline") {
	$newsheadlinebox = give_back(fetch_headline($bsx_conf[nhl_signanz],$bsx_conf[nhl_modeval],$bsx_conf[nhl_mode]), "newsheadlinebox");
	eval("print dooutput(\"".gettemplate("news_headline")."\");");
}
if($nshow == "newspreview") {
	$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
	$iquery = $dbcon->db_fetch("SELECT title, name FROM $db_tab[news_icon] WHERE id = '$HTTP_POST_VARS[NewsIcon]'");
	$elem = Array("title" => "$HTTP_POST_VARS[news_titel]",
			    "news" => "$HTTP_POST_VARS[message]",
			    "icon" => "$iquery[name]",
			    "icon_title" => "$iquery[title]",
			    "Link" => "$HTTP_POST_VARS[news_link]",
			    "Linktext" => "$HTTP_POST_VARS[news_linktext]",
			    "author" => $bsxadm,
			    "Datum" => time(),
			    "anz" => 0);
	eval("print give_back(\$elem, \"news\");");
}
if($nshow == "postnews") {
    
    $dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
	$icon_query = $dbcon->db_fetch_multi("SELECT * FROM $db_tab[news_icon]");
	$close = $dbcon->close();
	if($icon_query) {
		$news_icon = "<select style=\"font-family:{fontface}; color:{fontcolor}; width:90%; font-size:{fontsize};\""
		            ." name=\"NewsIcon\">";
		foreach($icon_query as $icon_query_detail) {
			foreach($icon_query_detail as $key=>$icon_elem) {
				$news_icon .= "<option value=\"$icon_elem[id]\">$icon_elem[title]</option>";
			}
		}
		$news_icon .= "</select>";
	}
	eval("print dooutput(\"".gettemplate("useraddnews")."\");");
    
    
}
// Zusatz Links
if(isset($_COOKIE["bsxadm"])) {
	$adminstring = "<a href=\"".$bsx_conf[site_url]."acp/\" target=\"_blank\"><small>Admin-Bereich</small></a>";
}
if(($nshow != "news") && ($nshow != "headline")) {
	$navstring = "<a href=\"".basename($PHP_SELF)."?nshow=news\"><small>Zur&uuml;ck zu den News!</small></a>";
} 
print "<p align=\"center\">".$navstring."<br>".$adminstring."</p>\n";
?>
