<?php
session_start();
/*
* Register Globals stress
*/
if (! ini_get('register_globals')) { 
	$register_order = array('GET','POST','COOKIE','SESSION','SERVER'); 
	foreach ($register_order as $order) { 
		if (@count(${'HTTP_'.$order.'_VARS'}) > 0) { 
			extract(${'HTTP_'.$order.'_VARS'}, EXTR_OVERWRITE); 
		} 
	} 
}
//if($imode == "update") header("Location: update.php?mode=1&step=3");;
?>
<?php
/*
* Installations Routine fr BSX-News v 1.10
*/
require("_dat.inc.php");
if(! class_exists(db_bsx)) include("_sql.php");
if(! isset($step)) $step = 1;
?>
<html><head><title>Willkommen zur Installation von BSX-News - Schritt <?php print $step; ?></title>
<link rel="StyleSheet" type="text/css" href="acp/style.css">
</head>
<body marginwidth="20" marginheight="20" topmargin="20" leftmargin="20">
<table width="90%" cellpadding="2" cellspacing="1" border="0" align="center" valign="top" bgcolor="#181818" align="center">
<tr>
<td width="100%" bgcolor="#006699" align="center" valign="top" nowrap><font color="#DCDCDC"><b>Willkommen zur Installation von BSX-News v 1.30 - Schritt <?php print $step; ?></b></font></td>
</tr><tr>
<td width="100%" bgcolor="#FFFFFF" align="left" valign="top" style="padding: 40;"><br>
<?php 
if($step == 1) {

	// setze Ordnerrechte (funktioniert nur unter *nix Server wenn der Webserver unter dem gleichen User luft wie dieses Script)
	@chmod("./_dat.inc.php", 0777);
	@chmod("./gfx/icons/", 0777);
	// checke nach Bedingungen
	$phpvers = phpversion();
	if($phpvers > "4.0.1") {
		$check[phpvers] = "<font color=green>$phpvers</font>";
		$check[errorcount][1] = 0;
	} else {
		$check[phpvers] = "<font color=red>$phpvers</font>";
		$check[errorcount][1] = 1;
	}
	$upsize = ini_get("upload_max_filesize");
	if($upsize > 0) {
		$check[upsize] = "<font color=green>$upsize</font>";
		$check[errorcount][2] = 0;
	} else {
		$check[upsize] = "<font color=red>$upsize</font>";
		$check[errorcount][2] = 1;
	}
	if(is_writeable("_dat.inc.php")) {
		$check[datinc] = "<font color=green>JA</font>";
		$check[errorcount][3] = 0;
	} else {
		$check[datinc] = "<font color=red>NEIN</font>";
		$check[errorcount][3] = 1;
	}
	if(is_writeable("gfx/icons")) {
		$check[icons] = "<font color=green>JA</font>";
		$check[errorcount][4] = 0;
	} else {
		$check[icons] = "<font color=red>NEIN</font>";
		$check[errorcount][4] = 1;
	}
?>	
	Willkommen zur BSX-News Installation!
	<p>
	<table width="80%" cellpadding="4" cellspacing="0" border="0">
	<tr>
	<td width="100%" align="left" valign="middle"><u>Systemvoraussetzungen:</u></td>
	</tr><tr>
	<td width="100%" align="left" valign="middle" bgcolor="">
		<table width="80%" height="100%" cellpadding="2" cellspacing="1" border="0">
		<tr>
		<td width="50%" align="left" valign="top"><u>Voraussetzung</u></td>
		<td width="25%" align="center" valign="top"><u>erforderlich</u></td>
		<td width="25%" align="center" valign="top"><u>vorhanden</u></td>
		</tr><tr>
		<td width="50%" align="left" valign="top">PHP Version</td>
		<td width="25%" align="center" valign="top">4.0.1</td>
		<td width="25%" align="center" valign="top"><?php print $check[phpvers]; ?></td>
		</tr><tr>
		<td width="50%" align="left" valign="top">upload_max_filesize</td>
		<td width="25%" align="center" valign="top">> 0</td>
		<td width="25%" align="center" valign="top"><?php print $check[upsize]; ?></td>
		</tr><tr>
		<td width="50%" align="left" valign="top">Schreibrechte auf "_dat.inc.php"</td>
		<td width="25%" align="center" valign="top">JA</td>
		<td width="25%" align="center" valign="top"><?php print $check[datinc]; ?></td>
		</tr><tr>
		<td width="50%" align="left" valign="top">Schreibrechte in "gfx/icons/"</td>
		<td width="25%" align="center" valign="top">JA</td>
		<td width="25%" align="center" valign="top"><?php print $check[icons]; ?></td>
		</tr><tr>
		<td colspan="3" width="100%" align="left" valign="top"><small>
		<font color=red><b>&raquo;</b></font>&nbsp;Sollten eine oder mehrere Voraussetzungen nicht erfllt sein, 
		kann ein einwandfreier Betrieb des Newssystems nicht gewhrleistet werden.</small></td>
		</tr><tr>
		<td colspan="3" width="100%" align="center" valign="bottom">&nbsp;</td>
		</tr><tr>
		<td width="50%" align="left" valign="middle"><u>Installationsart whlen!</u></td>
		<td colspan="2" width="50%" align="center" valign="middle">
		<form action="install-news.php" method="post">
		<input type="hidden" name="step" value="<?php print $step+1; ?>">
		<select name="imode" class="input">
		<option value="new" selected> Neuinstallation! </option>
		<option value="update"> Update (v 1.10 -> v. 1.30)</option>
		</select></td>
		</tr><tr>
		<td colspan="3" width="100%" align="center" valign="bottom"><br>
		<input class="inputbtn" type="submit" name="send" value="Weiter ->"></td>
		</tr>
		</table></form>
	</td>
	</tr></table></p>
	<small>Im nchsten Schritt werden nun die erforderlichen Daten ermittelt und in die _dat.inc.php eingetragen!</small>  
<?php
	
	//unset($check);

} elseif($step == 2) {

?>
	<p>
	<table width="80%" cellpadding="4" cellspacing="0" border="0">
	<tr>
	<td width="100%" align="left" valign="middle"><u>Datenbankzugriffsdaten:</u></td>
	</tr><tr>
	<td width="100%" align="left" valign="middle" bgcolor="">
		<form action="install-news.php" method="post">
		<table width="80%" height="100%" cellpadding="2" cellspacing="1" border="0">
		<tr>
		<td width="40%" align="left" valign="middle">Adresse des Datenbankservers:</td>
		<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_new[host]" value="<?php print $db_host; ?>"></td>
		</tr><tr>
		<td width="40%" align="left" valign="middle">Datenbank-Benutzername:</td>
		<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_new[user]" value="<?php print $db_user; ?>"></td>
		</tr><tr>
		<td width="40%" align="left" valign="middle">Datenbank-Benutzerpasswort:</td>
		<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_new[pass]" value="<?php print $db_pass; ?>"></td>
		</tr><tr>
		<td width="40%" align="left" valign="middle">Datenbankname:</td>
		<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_new[name]" value="<?php print $db_name; ?>"></td>
		</tr>
<?php
	if($imode == "update") {
?>
		<tr>
		<td width="100%" colspan="2" align="left" valign="middle"><u>Tabellennamen der Version 1.10</u> <small><font color=red>*Wichtig! hier die alten Tabellennamen eintragen!</font></small></td>
		</tr><tr>
		<td width="40%" align="left" valign="middle">alte News Tabelle:</td>
		<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_old[news]" value="<?php print $db_old[news]; ?>"></td>
		</tr><tr>
		<td width="40%" align="left" valign="middle">alte Newscomments Tabelle:</td>
		<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_old[news_com]" value="<?php print $db_old[news_com]; ?>"></td>
		</tr><tr>
		<td width="40%" align="left" valign="middle">alte Newsicons Tabelle:</td>
		<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_old[news_icon]" value="<?php print $db_old[news_icon]; ?>"></td>
		</tr><tr>
		<td width="40%" align="left" valign="middle">alte User Tabelle:</td>
		<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_old[users]" value="<?php print $db_old[users]; ?>"></td>
		</tr><tr>
		<td width="40%" align="left" valign="middle">alte Newsdesign Tabelle:</td>
		<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_old[style]" value="<?php print $db_old[style]; ?>"></td>
		</tr><tr>
		<td width="40%" align="left" valign="middle">alte Newsconfig Tabelle:</td>
		<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_old[config]" value="<?php print $db_old[config]; ?>"></td>
		</tr>
<?php	
	}		
?>
		<tr>
		<td width="100%" colspan="2" align="left" valign="middle"><u>Tabellennamen</u> <small><font color=red>*Nur bei mehrfach Installlation ndern!</font></small></td>
		</tr><tr>
		<td width="40%" align="left" valign="middle">News Tabelle:</td>
		<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_new[news]" value="<?php print $db_tab[news]; ?>"></td>
		</tr><tr>
		<td width="40%" align="left" valign="middle">Newscomments Tabelle:</td>
		<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_new[news_com]" value="<?php print $db_tab[news_com]; ?>"></td>
		</tr><tr>
		<td width="40%" align="left" valign="middle">Newsicons Tabelle:</td>
		<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_new[news_icon]" value="<?php print $db_tab[news_icon]; ?>"></td>
		</tr><tr>
		<td width="40%" align="left" valign="middle">User Tabelle:</td>
		<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_new[users]" value="<?php print $db_tab[users]; ?>"></td>
		</tr><tr>
		<td width="40%" align="left" valign="middle">Newsdesign Tabelle:</td>
		<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_new[style]" value="<?php print $db_tab[style]; ?>"></td>
		</tr><tr>
		<td width="40%" align="left" valign="middle">Newsconfig Tabelle:</td>
		<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_new[config]" value="<?php print $db_tab[config]; ?>"></td>
		</tr><tr>
		<td width="40%" align="left" valign="middle">User Gruppen Tabelle:</td>
		<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_new[usergroups]" value="<?php print $db_tab[usergroups]; ?>"></td>
		</tr><tr>
		<td width="100%" colspan="2" align="center" valign="middle">
		<input type="hidden" name="imode" value="<?php print $imode; ?>">
		<input type="hidden" name="step" value="<?php print $step; ?>">
		<input type="submit" name="send" class="inputbtn" value="Speichern">&nbsp;
		<input type="reset" name="send" class="inputbtn"></td>
		</tr>
		</table></form>
	</td>
	</tr></table></p>
<?php
	if($send == "Speichern") {
		$incheck = 0;
		if($incheck == 0) {
			$confdat = "<?php\n\n"
				  ."/*\n* Bsx-News version 1.30 Config Datei\n*/\n\n"
				  ."\$db_host = \"".str_replace("\"","\\\\\"",$db_new[host])."\";"
				  ."\t\t\t// Datenbank Server\n"
				  ."\$db_user = \"".str_replace("\"","\\\\\"",$db_new[user])."\";"
				  ."\t\t\t// Datenbank User/Account\n"
				  ."\$db_pass = \"".str_replace("\"","\\\\\"",$db_new[pass])."\";"
				  ."\t\t\t// Datenbank Passwort\n"
				  ."\$db_name = \"".str_replace("\"","\\\\\"",$db_new[name])."\";"
				  ."\t\t\t// Datenbank Name\n"
				  ."\n/*\n* Tabellen Namen - Nur bei mehrfach Installlation\n*/\n\n"
				  ."\$db_tab[news] = \"".str_replace("\"","\\\\\"",$db_new[news])."\";"
				  ."\t\t\t// Tabelle fr die News\n"
				  ."\$db_tab[news_com] = \"".str_replace("\"","\\\\\"",$db_new[news_com])."\";"
				  ."\t\t\t// Tabelle fr die News comments\n"
				  ."\$db_tab[news_icon] = \"".str_replace("\"","\\\\\"",$db_new[news_icon])."\";"
				  ."\t\t\t// Tabelle fr die News Icons\n"
				  ."\$db_tab[users] = \"".str_replace("\"","\\\\\"",$db_new[users])."\";"
				  ."\t\t\t// Tabelle fr die Admin user\n"
				  ."\$db_tab[style] = \"".str_replace("\"","\\\\\"",$db_new[style])."\";"
				  ."\t\t\t// Tabelle fr Style\n"
				  ."\$db_tab[config] = \"".str_replace("\"","\\\\\"",$db_new[config])."\";"
				  ."\t\t\t// Tabelle fr die Einstellungen\n"
				  ."\$db_tab[usergroups] = \"".str_replace("\"","\\\\\"",$db_new[usergroups])."\";"
				  ."\t\t\t// Tabelle fr die Usergruppen\n"
				  ."\n/*\n* Template Einstellungen\n*/\n\n"
				  ."\$ext = \"htm\";\t\t\t// Dateiendung der Templates\n"
				  ."\$templatedir = \"tpl\";\t\t\t// Ordner der Templates\n"
				  ."\$tplcache = Array();\n?>";
			$cur = fopen("_dat.inc.php", "w+");
			@flock($cur, 2);
			if(fputs($cur, $confdat)) {
?>
<center><p><font color=green>Config Datei gespeichert!</font></p>
<form action="install-news.php" method="post">
<input type="hidden" class="input" name="db_old[news]" value="<?php print $db_old[news]; ?>">
<input type="hidden" class="input" name="db_old[news_com]" value="<?php print $db_old[news_com]; ?>">
<input type="hidden" class="input" name="db_old[news_icon]" value="<?php print $db_old[news_icon]; ?>">
<input type="hidden" class="input" name="db_old[users]" value="<?php print $db_old[users]; ?>">
<input type="hidden" class="input" name="db_old[style]" value="<?php print $db_old[style]; ?>">
<input type="hidden" class="input" name="db_old[config]" value="<?php print $db_old[config]; ?>">
<input type="hidden" name="imode" value="<?php print $imode; ?>">
<input type="hidden" name="step" value="<?php print $step+1; ?>">
<input class="inputbtn" type="submit" name="send" value="Weiter ->"></form></center>
<br><small>Im nchsten Schritt werden nun die Tabellen in der Datenbank angelegt die fr BSX-News bentigt werden.</small>
<?php				
			}
			@flock($cur, 3);
			@fclose($cur);
		}		
	}

} elseif($step == 3) {
	if($imode == "update") {
/*
*  neue Tabellenstruktur fr News Tabelle
*/
		$nquery = "ALTER TABLE $db_old[news] ADD active ENUM( '1', '0' ) DEFAULT '1' NOT NULL";

/*
*  Tabellenstruktur fr neue Style Tabelle
*/
	$squery = "ALTER TABLE $db_old[style] ADD bodybg VARCHAR(15) NOT NULL AFTER name,
			  ADD fontface VARCHAR(25) NOT NULL AFTER bodybg,
			  ADD fontsize VARCHAR(5) NOT NULL AFTER fontface,
			  ADD fontcolor VARCHAR(15) NOT NULL AFTER fontsize,
			  ADD titelfontsize VARCHAR(5) NOT NULL AFTER fontcolor,
			  ADD titelfontcolor VARCHAR(15) NOT NULL AFTER titelfontsize,
			  ADD catfontsize VARCHAR(5) NOT NULL AFTER titelfontcolor,
			  ADD catfontcolor VARCHAR(15) NOT NULL AFTER catfontsize,
			  ADD link VARCHAR(15) NOT NULL AFTER catfontcolor,
			  ADD linka VARCHAR(15) NOT NULL AFTER link,
			  ADD linkv VARCHAR(15) NOT NULL AFTER linka";
/*
*  Tabellenstruktur fr User-Gruppen Tabelle
*/
	$usergroup_dummy ="
	CREATE TABLE $db_tab[usergroups] (
	  id MEDIUMINT(5) NOT NULL auto_increment,
	  group_name VARCHAR(100) NOT NULL default '',
	  settings ENUM('1','0') NOT NULL default '1',
	  news ENUM('1','0') NOT NULL default '1',
	  allnews ENUM('1','0') NOT NULL default '1',
	  user ENUM('1','0') NOT NULL default '1',
	  intern ENUM('1','0') NOT NULL default '1',
	  PRIMARY KEY  (id)
	) TYPE=MyISAM";
/*
*  Tabellenstruktur fr neue User Tabelle
*/
	$uquery = "ALTER TABLE $db_old[users] ADD group_id SMALLINT(2) NOT NULL AFTER pass";
		
// umbennen der tabellen in die neuen namen
	$ren_news = "ALTER TABLE $db_old[news] RENAME $db_tab[news]";
	$ren_style = "ALTER TABLE $db_old[style] RENAME $db_tab[style]";
	$ren_newsuser = "ALTER TABLE $db_old[users] RENAME $db_tab[users]";	
// und weiter gehts ;o)				
		print "Verbindung zur Datenbank wird aufgebaut!<p><u>Status:</u></p>";
		$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
		$test1 = $dbcon->db_ins("CREATE TABLE dummytest (dummy int(1) NOT NULL) TYPE=MyISAM;");
        	$test2 = $dbcon->db_ins("DROP TABLE dummytest");
       		if (($test1) && ($test2)) { 
				print "<font color=green>- Verbindung aufgebaut!</font>";
				print "<p>Die Tabellen werden nun gendert/erstellt ...</p>";
			// ndern der struktur
				$news_query = $dbcon->db_ins($nquery);
				if($db_old[news] != $db_tab[news])
					$news_query2 = $dbcon->db_ins($ren_news);
				else $news_query2 = true;
				
				$style_query = $dbcon->db_ins($squery);
				if($db_old[style] != $db_tab[style])
					$style_query2 = $dbcon->db_ins($ren_style);
				else $style_query2 = true;
				
				$user_query = $dbcon->db_ins($uquery);
				if($db_old[users] != $db_tab[users])
					$user_query2 = $dbcon->db_ins($ren_newsuser);
				else $user_query2 = true;
				
				$del_usergroup = $dbcon->db_ins("DROP TABLE IF EXISTS $db_tab[usergroups];");
				$usergroup_query = $dbcon->db_ins($usergroup_dummy);
				
			// checken
				if(($news_query) && ($news_query2)) {
					print "<font color=green>- News Tabelle erfolgreich gendert!</font><br>";
					$checkall = true;
				} else {
					print "<font color=red>- Fehler, konnte News Tabelle nicht ndern!</font><br>";
					$checkall = false;
				}
				if(($style_query) && ($style_query2)) {
					print "<font color=green>- Style Tabelle erfolgreich gendert!</font><br>";
					$checkall = true;
				} else {
					print "<font color=red>- Fehler, konnte Style Tabelle nicht ndern!</font><br>";
					$checkall = false;
				}
				if(($user_query) && ($user_query2)) {
					print "<font color=green>- User Tabelle erfolgreich gendert!</font><br>";
					$checkall = true;
				} else {
					print "<font color=red>- Fehler, konnte User Tabelle nicht ndern!</font><br>";
					$checkall = false;
				}
				
				if($usergroup_query) {
					print "<font color=green>- User Gruppen Tabelle erfolgreich erstellt!</font><br>";
					$checkall = true;
				} else {
					print "<font color=red>- Fehler, konnte User Gruppen Tabelle nicht erstellen!</font><br>";
					$checkall = false;
				}
				$close = $dbcon->close();
			} else {
				print "<font color=red><b>Verbindung konnte nicht aufgebaut werden!</b></font><br>";
				print "<p>&Uuml;berpr&uuml;fe nochmals alle Angaben in der \"_dat_inc.php\".<br>";
				print "Vergewisser Dich das deine Datenbank funktionstchtig ist.<br>";
				print "Wende dich gegebenfalls an deinen Webhoster / Systemadministrator ...</p>";
			}
	} else {
		print "Verbindung zur Datenbank wird aufgebaut!<p><u>Status:</u></p>";
		$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
		$test1 = $dbcon->db_ins("CREATE TABLE dummytest (dummy int(1) NOT NULL) TYPE=MyISAM;");
        	$test2 = $dbcon->db_ins("DROP TABLE dummytest");
       		if (($test1) && ($test2)) { 
			print "<font color=green>- Verbindung aufgebaut!</font>";
			print "<p>Die Tabellen werden nun erstellt ...</p>";
	/*
	*  Tabellenstruktur fr News Tabelle
	*/
			$news_dummy = "
			CREATE TABLE $db_tab[news] (
			  id int(10) NOT NULL auto_increment,
			  title varchar(255) NOT NULL default '',
			  news longtext NOT NULL,
			  icon varchar(255) NOT NULL default '',
			  icon_title varchar(50) NOT NULL default '',
			  Link varchar(255) NOT NULL default '',
			  Linktext varchar(255) NOT NULL default '',
			  author varchar(255) NOT NULL default '',
			  Datum varchar(20) NOT NULL default '',
			  active enum('1','0') NOT NULL default '1',
			  PRIMARY KEY  (id),
			  KEY id (id),
			  KEY author (author)
			) TYPE=MyISAM";

	/*
	*   Tabellenstruktur fr Newscomment Tabelle
	*/
		 	$news_com_dummy = "
		 	CREATE TABLE $db_tab[news_com] (
		 	  id int(10) NOT NULL auto_increment,
			  news_id int(10) default NULL,
			  title varchar(255) NOT NULL default '',
			  comment text NOT NULL,
			  author varchar(255) NOT NULL default '',
			  email varchar(255) NOT NULL default '',
			  Datum varchar(255) NOT NULL default '',
			  PRIMARY KEY  (id),
			  KEY news_id (news_id)
			) TYPE=MyISAM";

	/*
	*  Tabellenstruktur fr Newsicon Tabelle
	*/		
			$news_icon_dummy = "
			CREATE TABLE $db_tab[news_icon] (
			  id int(10) NOT NULL auto_increment,
			  title varchar(255) NOT NULL default '',
			  name varchar(255) NOT NULL default '',
			  PRIMARY KEY  (id),
			  KEY id (id)
			) TYPE=MyISAM";
	/*
	*  Tabellenstruktur fr Tabelle $db_users
	*/
			$user_dummy ="
			CREATE TABLE $db_tab[users] (
			  id int(10) NOT NULL auto_increment,
			  user varchar(50) NOT NULL default '',
			  pass varchar(50) NOT NULL default '',
			  group_id smallint(2) default '0',
			  email varchar(150) default NULL,
			  PRIMARY KEY  (id),
			  UNIQUE KEY user (user)
			) TYPE=MyISAM";
	
	/*
	*  Tabellenstruktur fr Config Tabelle
	*/
			$config_dummy ="
			CREATE TABLE $db_tab[config] (
			  news_max tinyint(2) NOT NULL default '0',
			  news_com_max tinyint(2) NOT NULL default '0',
			  news_icon_size varchar(10) NOT NULL default '640x480',
			  news_icon_view enum('on','off') NOT NULL default 'on',
			  site_name varchar(100) NOT NULL default '',
			  site_url varchar(255) NOT NULL default '',
			  site_path varchar(255) NOT NULL default '',
			  nhl_signanz int(3) NOT NULL default '50',
			  nhl_mode enum('stk','m','w','d') NOT NULL default 'stk',
			  nhl_modeval int(4) NOT NULL default '25',
			  version varchar(4) NOT NULL default ''
			) TYPE=MyISAM";	
	/*
	*  Tabellenstruktur fr Style Tabelle
	*/		
			$style_dummy ="
			CREATE TABLE $db_tab[style] (
			  id int(4) NOT NULL auto_increment,
			  name varchar(50) NOT NULL default '',
			  bodybg varchar(15) NOT NULL default '',
			  fontface varchar(25) NOT NULL default '',
			  fontsize varchar(5) NOT NULL default '',
			  fontcolor varchar(15) NOT NULL default '',
			  titelfontsize varchar(5) NOT NULL default '',
			  titelfontcolor varchar(15) NOT NULL default '',
			  catfontsize varchar(5) NOT NULL default '',
			  catfontcolor varchar(15) NOT NULL default '',
			  link varchar(15) NOT NULL default '',
			  linka varchar(15) NOT NULL default '',
			  linkv varchar(15) NOT NULL default '',
			  titlebg varchar(7) NOT NULL default '',
			  catbg varchar(7) NOT NULL default '',
			  taba varchar(7) NOT NULL default '',
			  tabb varchar(7) NOT NULL default '',
			  tabc varchar(7) NOT NULL default '',
			  tabout varchar(7) NOT NULL default '',
			  style longtext NOT NULL,
			  standard char(2) NOT NULL default 'No',
			  PRIMARY KEY  (id)
			) TYPE=MyISAM";
			
	/*
	*  Tabellenstruktur fr User-Gruppen Tabelle
	*/
		$usergroup_dummy ="
		CREATE TABLE $db_tab[usergroups] (
		  id MEDIUMINT(5) NOT NULL auto_increment,
		  group_name VARCHAR(100) NOT NULL default '',
		  settings ENUM('1','0') NOT NULL default '1',
		  news ENUM('1','0') NOT NULL default '1',
		  allnews ENUM('1','0') NOT NULL default '1',
		  user ENUM('1','0') NOT NULL default '1',
		  intern ENUM('1','0') NOT NULL default '1',
		  PRIMARY KEY  (id)
		) TYPE=MyISAM";		
			
			$del = $dbcon->db_ins("DROP TABLE IF EXISTS $db_tab[news];");
			$news_query = $dbcon->db_ins($news_dummy);
			if($news_query) {
				print "<font color=green>- News Tabelle erfolgreich erstellt!</font><br>";
				$checkall = true;
			} else {
				print "<font color=red>- Fehler, konnte News Tabelle nicht erstellen!</font><br>";
				$checkall = false;
			}
			$del = $dbcon->db_ins("DROP TABLE IF EXISTS $db_tab[news_com];");
			$news_com_query = $dbcon->db_ins($news_com_dummy);
			if($news_com_query) {
				print "<font color=green>- News-Comment Tabelle erfolgreich erstellt!</font><br>";
				$checkall = true;
			} else {
				print "<font color=red>- Fehler, konnte News-Comment Tabelle nicht erstellen!</font><br>";
				$checkall = false;
			}
			$del = $dbcon->db_ins("DROP TABLE IF EXISTS $db_tab[news_icon];");
			$news_icon_query = $dbcon->db_ins($news_icon_dummy);
			if($news_icon_query) {
				print "<font color=green>- News-Icon Tabelle erfolgreich erstellt!</font><br>";
				$checkall = true;
			} else {
				print "<font color=red>- Fehler, konnte News-Icon Tabelle nicht erstellen!</font><br>";
				$checkall = false;
			}
			$del = $dbcon->db_ins("DROP TABLE IF EXISTS $db_tab[users];");
			$user_query = $dbcon->db_ins($user_dummy);
			if($user_query) {
				print "<font color=green>- User Tabelle erfolgreich erstellt!</font><br>";
				$checkall = true;
			} else {
				print "<font color=red>- Fehler, konnte User Tabelle nicht erstellen!</font><br>";
				$checkall = false;
			}
			
			$del = $dbcon->db_ins("DROP TABLE IF EXISTS $db_tab[config];");
			$config_query = $dbcon->db_ins($config_dummy);
			if($config_query) {
				print "<font color=green>- Config Tabelle erfolgreich erstellt!</font><br>";
				$checkall = true;
			} else {
				print "<font color=red>- Fehler, konnte Config Tabelle nicht erstellen!</font><br>";
				$checkall = false;
			}
			
			$del = $dbcon->db_ins("DROP TABLE IF EXISTS $db_tab[style];");
			$style_query = $dbcon->db_ins($style_dummy);
			if($style_query) {
				print "<font color=green>- Style Tabelle erfolgreich erstellt!</font><br>";
				$checkall = true;
			} else {
				print "<font color=red>- Fehler, konnte Style Tabelle nicht erstellen!</font><br>";
				$checkall = false;
			}
			$del = $dbcon->db_ins("DROP TABLE IF EXISTS $db_tab[usergroups];");
			$usergroup_query = $dbcon->db_ins($usergroup_dummy);
			if($usergroup_query) {
				print "<font color=green>- User Gruppen Tabelle erfolgreich erstellt!</font><br>";
				$checkall = true;
			} else {
				print "<font color=red>- Fehler, konnte User Gruppen Tabelle nicht erstellen!</font><br>";
				$checkall = false;
			}
			$close = $dbcon->close();
		} else { 
			print "<font color=red><b>Verbindung konnte nicht aufgebaut werden!</b></font><br>";
			print "&Uuml;berpr&uuml;fe nochmals alle Angaben in der \"_dat_inc.php\".<br>";
			print "Vergewisser Dich das deine Datenbank funktionstchtig ist.<br>";
			print "Wende dich gegebenfalls an deinen Webhoster / Systemadministrator ...<br>";
		}
	}
?>
	<p><form action="<?php print basename($PHP_SELF); ?>" method="post">
	<input type="hidden" name="db_old" value="<?php print serialize($db_old); ?>">
	<input type="hidden" name="imode" value="<?php print $imode; ?>">
	<input type="hidden" name="step" value="<?php print $step+1; ?>">
	<input type="submit" class="inputbtn" name="send" value="Weiter ->">
	</form></p><small>Im nchsten Schritt werden die Tabellen mit Daten gefllt!</small>	
<?php
} elseif ($step == 4) {
	// Installationsmodi = update
	if($imode == "update") {
		print "Verbindung zur Datenbank wird aufgebaut!<p><u>Status:</u></p>";
		$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
		$test1 = $dbcon->db_ins("CREATE TABLE dummytest (dummy int(1) NOT NULL) TYPE=MyISAM;");
        	$test2 = $dbcon->db_ins("DROP TABLE dummytest");
       		if (($test1) && ($test2)) { 
			print "<font color=green>- Verbindung aufgebaut!</font>";
			print "<p>Die Tabellen werden nun mit Daten gefllt ...</p>";
		
		// Fllen der User Gruppen Tabelle
			$query1 = "INSERT INTO $db_tab[usergroups] VALUES (1, 'Administrator', '1', '1', '1', '1', '1')";
			$query2 = "INSERT INTO $db_tab[usergroups] VALUES (2, 'Super Moderator', '0', '1', '1', '0', '1')";
			$query3 = "INSERT INTO $db_tab[usergroups] VALUES (3, 'Moderator', '0', '1', '0', '0', '1')";
			$query4 = "INSERT INTO $db_tab[usergroups] VALUES (4, 'Coder/Designer', '1', '1', '0', '0', '1')";
			$ug_query1 = $dbcon->db_ins($query1);
			$ug_query2 = $dbcon->db_ins($query2);
			$ug_query3 = $dbcon->db_ins($query3);
			$ug_query4 = $dbcon->db_ins($query4);
			if($ug_query1 && $ug_query2 && $ug_query3 && $ug_query4) {
				print "<font color=green>- User Gruppen Tabelle erfolgreich gefllt!</font><br>";
				$result = $dbcon->db_fetch_multi("SELECT * FROM $db_tab[users] ORDER BY id ASC");
				if($result) {
?>
<p>
<table width="50%" cellpadding="4" cellspacing="1" border="0" bgcolor="#808080" align=left>
<tr><form action="install-news.php" method="post">
<td colspan=2 width="100%" align="center" valign="middle" bgcolor="#FFFFFF"><b>Admin User whlen!</b></td>
</tr>

<?php
					foreach($result as $rsd) {
						foreach($rsd as $key=>$elem1) {
?>
<tr>
<td width="10%" align="center" bgcolor="#FFFFFF"><input type="radio" name="setadmin" value="<?php print $elem1[id]; ?>"></td>
<td width="90%" align="left" valign="middle" bgcolor="#FFFFFF"><?php print $elem1[user]; ?></td>
</tr>
<?php
						}
					}				// end foreach
?>
<tr>
<td colspan=2 width="100%" align="center" valign="middle" bgcolor="#FFFFFF">
<input type="submit" class="inputbtn" name="send" value="Admin setzen"></td>
</tr><input type="hidden" name="step" value="<?php print $step+1; ?>"></form>
</table></p><p>&nbsp;<br><bR></p>
<?php					
				} 			// end if result	
			} else {
				print "<font color=red>- Fehler, konnte User Gruppen Tabelle nicht fllen!</font><br>";
			}
		} else { 
			print "<font color=red><b>Verbindung konnte nicht aufgebaut werden!</b></font><br>";
			print "&Uuml;berpr&uuml;fe nochmals alle Angaben in der \"_dat_inc.php\".<br>";
			print "Vergewisser Dich das deine Datenbank funktionstchtig ist.<br>";
			print "Wende dich gegebenfalls an deinen Webhoster / Systemadministrator ...<br>";
		}
	// Installationsmodi = new
	} else {
		print "Verbindung zur Datenbank wird aufgebaut!<p><u>Status:</u></p>";
		$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
		$test1 = $dbcon->db_ins("CREATE TABLE dummytest (dummy int(1) NOT NULL) TYPE=MyISAM;");
        	$test2 = $dbcon->db_ins("DROP TABLE dummytest");
       		if (($test1) && ($test2)) { 
			print "<font color=green>- Verbindung aufgebaut!</font>";
			print "<p>Die Tabellen werden nun mit Daten gefllt ...</p>";
			// Fllen der News Tabelle
			$query = "INSERT INTO $db_tab[news] VALUES (1,
								    'Herzlichen Glckwunsch',
								    'Herzlichen Glckwunsch!<br><br>Sie haben erfolgreich BSX-News v 1.30 installiert, diese News knnen Sie im Admin Control Panel (acp) editieren oder lschen.<br><br>Viel Spass noch mit BSX-News v 1.10.',
								    'news.gif',
								    'News',
								    'http://www.bsx.bmw-tune.de/',
								    'BSX-Design',
								    'author',
								    '".time()."',
								    '1')";
			$news_query = $dbcon->db_ins($query);
			if($news_query) {
				print "<font color=green>- News Tabelle erfolgreich gefllt!</font><br>";
				$checkall = true;
			} else {
				print "<font color=red>- Fehler, konnte News Tabelle nicht fllen!</font><br>";
				$checkall = false;
			}
			// Fllen der Newsicon Tabelle
			$iconarr = Array("INSERT INTO $db_tab[news_icon] VALUES (1, 'News', 'news.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (2, 'Hardware-News', 'tower.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (3, 'AMD-News', 'amd.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (4, 'Apple-News', 'apple.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (5, 'Apache-News', 'apache.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (6, 'Audio-News', 'audio.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (7, 'Beos-News', 'beos.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (8, 'Updates/Patches', 'bug.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (9, 'Coding/Scripting-News', 'coding.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (10, 'CS-News', 'cs.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (11, 'Ebay-News', 'ebay.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (12, 'Game-News', 'games.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (13, 'Gnome-News', 'gnome.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (14, 'Mobile-News', 'handy.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (15, 'Intel-News', 'intel.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (16, 'Interviews', 'interview.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (17, 'Java-News', 'java.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (18, 'Kde-News', 'kde.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (19, 'Links', 'links.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (20, 'Linux-News', 'linux.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (21, 'Movies', 'movies.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (22, 'Musik-News', 'music.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (23, 'Nvidia-News', 'nvidia.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (24, 'PDA-News', 'pda.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (25, 'PHP-News', 'php.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (26, 'Python-News', 'python.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (27, 'Quake-News', 'quake.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (28, 'Radio-News', 'radio.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (29, 'Realmedia-News', 'realmedia.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (30, 'Security-News', 'security.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (31, 'Software-News', 'software.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (32, 'TV-News', 'tv.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (33, 'VIA-News', 'via.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (34, 'Microsoft-News', 'win.gif')",
					 "INSERT INTO $db_tab[news_icon] VALUES (35, 'WWW-News', 'www.gif')");
			for($x=0;$x<count($iconarr);$x++) {
				if($dbcon->db_ins($iconarr[$x])) $iconcheck = 0; else $iconcheck = 1;
			}
			if($iconcheck == 0) {
				print "<font color=green>- Icon Tabelle erfolgreich gefllt!</font><br>";
				$checkall = true;
			} else {
				print "<font color=red>- Fehler, konnte Icon Tabelle nicht fllen!</font><br>";
				$checkall = false;
			}
			// Fllen der Style Tabelle
			$query = "INSERT INTO $db_tab[style] VALUES (1,
														'BSX-News',
														'#D1D1D1',
														'Verdana, Tahoma',
														'8pt',
														'black',
														'9pt',
														'white',
														'7pt',
														'black',
														'#0033FF',
														'#E68626',
														'#232323',
														'#006699',
														'#006699',
														'#E5E5E5',
														'#DDDDDD',
														'#CECECE',
														'#232323',
														'.title, .cat { background-image: url({script_url}gfx/title.gif); }',
														'Jo')";
			$style_query = $dbcon->db_ins($query);
			if($style_query) {
				print "<font color=green>- Style Tabelle erfolgreich gefllt!</font><br>";
				$checkall = true;
			} else {
				print "<font color=red>- Fehler, konnte Style Tabelle nicht fllen!</font><br>";
				$checkall = false;
			}
			// Fllen der Config Tabelle
			$query = "INSERT INTO $db_tab[config] VALUES (5,
								      8,
								      '640x480',
								      'on',
								      'Bsx-News',
								      'http://".$_SERVER[HTTP_HOST]."".str_replace(basename($_SERVER[REQUEST_URI]),"",$_SERVER[REQUEST_URI])."',
								      '".str_replace(basename($_SERVER[SCRIPT_FILENAME]), "", $_SERVER[SCRIPT_FILENAME])."',
								      80,
								      'w',
								      3,
								      '1.3')";
			$config_query = $dbcon->db_ins($query);
			if($config_query) {
				print "<font color=green>- Config Tabelle erfolgreich gefllt!</font><br>";
				$checkall = true;
			} else {
				print "<font color=red>- Fehler, konnte Config Tabelle nicht fllen!</font><br>";
				$checkall = false;
			}
			// Fllen der User Gruppen Tabelle
			$ugarr = Array("INSERT INTO $db_tab[usergroups] VALUES (1, 'Administrator', '1', '1', '1', '1', '1')",
					 "INSERT INTO $db_tab[usergroups] VALUES (2, 'Super Moderator', '0', '1', '1', '0', '1')",
					 "INSERT INTO $db_tab[usergroups] VALUES (3, 'Moderator', '0', '1', '0', '0', '1')",
					 "INSERT INTO $db_tab[usergroups] VALUES (4, 'Coder/Designer', '1', '1', '0', '0', '1')");
			for($x=0;$x<count($ugarr);$x++) {
				if($dbcon->db_ins($ugarr[$x])) $ugcheck = 0; else $ugcheck = 1;
			}
			if($ugcheck == 0) {
				print "<font color=green>- User Gruppen Tabelle erfolgreich gefllt!</font><br>";
				$checkall = true;
			} else {
				print "<font color=red>- Fehler, konnte User Gruppen Tabelle nicht fllen!</font><br>";
				$checkall = false;
			}
			$close = $dbcon->close();
		} else { 
			print "<b>Verbindung konnte nicht aufgebaut werden!</b><br>";
			print "&Uuml;berpr&uuml;fe nochmals alle Angaben in der \"_dat_inc.php\".<br>";
			print "Vergewisser Dich das deine Datenbank funktionstchtig ist.<br>";
			print "Wende dich gegebenfalls an deinen Webhoster / Systemadministrator ...<br>";
		}
	}
	if($checkall == true) {
?>
		<p>Nun wird der Admin fr Bsx-News erstellt!</p><p>
		<table width="80%" cellpadding="4" cellspacing="0" border="0">
		<tr>
		<td width="100%" align="left" valign="middle"><u>Admin erstellen:</u></td>
		</tr><tr>
		<td width="100%" align="left" valign="middle" bgcolor="">
			<form action="install-news.php" method="post">
			<table width="80%" height="100%" cellpadding="2" cellspacing="1" border="0">
			<tr>
			<td width="40%" align="left" valign="middle">Name:</td>
			<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_new[adminuser]"></td>
			</tr><tr>
			<td width="40%" align="left" valign="middle">Passwort:</td>
			<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_new[adminpass]"></td>
			</tr><tr>
			<td width="40%" align="left" valign="middle">Email:</td>
			<td width="60%" align="center" valign="middle"><input type="text" class="input" name="db_new[adminmail]"></td>
			</tr><tr>
			<td width="40%" align="left" valign="middle">Mitglied in Gruppe:</td>
			<td width="60%" align="center" valign="middle">
			<select name="db_new[admingroup]" class="input">
<?php
$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
$result = $dbcon->db_fetch_multi("SELECT id, group_name FROM $db_tab[usergroups] ORDER BY ID ASC");
$close = $dbcon->close();
if($result) {
	foreach($result as $rsd) {
		foreach($rsd as $key=>$elem2) {
			print "<option value=\"$elem2[id]\"> ".stripslashes($elem2[group_name])." </option>\n";
		}
	}
}
?>			
			</select>
			</td>
			</tr><tr>
			<td width="100%" colspan="2" align="center" valign="middle">
			<input type="hidden" name="step" value="<?php print $step+1; ?>">
			<input type="submit" name="send" class="inputbtn" value="Anlegen">&nbsp;
			<input type="reset" name="send" class="inputbtn"></td>
			</tr>
			</table></form>
		</td>
		</tr></table></p>
<?php	
	}		
} elseif ($step == 5) {	
		if($send == "Admin setzen") {
			$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
			$query = $dbcon->db_ins("UPDATE $db_tab[users] SET group_id = '1' WHERE id = '$setadmin'");
			$close = $dbcon->close();
			if($query) {
				print "<font color=green>- Adminrechte erfolgreich gesetzt!</font><br>\n";
			} else {
				print "<font color=red>- Konnte Adminrechte nicht setzen!</font><br>\n";
			}
?>
Die Installation ist hiermit abgeschlossen!
<p><b>Hinweis:</b><br>Bitte lsche die "install-news.php" von deinem Server (aus Sicherheitsgrnden)!</p>
Und hier nun die Links:<ul>
- Zum Admin Bereich <a href="acp/index.php" title="Zum Admin Bereich"><font color="#006699">Hier</font></a><br>
- Zu den News <a href="news_preview.php" title="Zu den News"><font color="#006699">Hier</font></a></ul>
<?php
		}	
		if($send == "Anlegen") {
			$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
			$query = "INSERT INTO $db_tab[users] (user, pass, group_id, email) VALUES ('$db_new[adminuser]', '".md5($db_new[adminpass])."', '$db_new[admingroup]', '$db_new[adminmail]')";
			$user_query = $dbcon->db_ins($query);
			$close = $dbcon->close();
			if($user_query) {
				print "<font color=green>- User Tabelle erfolgreich gefllt!</font><br>\n";
				$checkall = true;
			} else {
				print "<font color=red>- Fehler, konnte User Tabelle nicht fllen!</font><br>";
				$checkall = false;
			}
			if($checkall == true) {
?>
Die Installation ist hiermit abgeschlossen!
<p><b>Hinweis:</b><br>Bitte lsche die "install-news.php" von deinem Server (aus Sicherheitsgrnden)!</p>
Und hier nun die Links:<ul>
- Zum Admin Bereich <a href="acp/index.php" title="Zum Admin Bereich"><font color="#006699">Hier</font></a><br>
- Zu den News <a href="news_preview.php" title="Zu den News"><font color="#006699">Hier</font></a></ul>
<?php				
			}			
		}
} // step5
?>
</td>
</tr><tr>
<td width="100%" bgcolor="#006699" align="right" valign="top" nowrap>
<span align="right"><font color="#DCDCDC">&copy; 2003 BetaSux @ BSX-Design</font></span></td>
</tr>
</table><br>
</body></html>
